  
"
    __________________________________________________
    @Alejandro F. Reimondo 09/02/03
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"!

GenesisOtherExtensionsObject subclass: #GenesisBoidsModel
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

GenesisBoidsModel subclass: #BoidBehavior
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

BoidBehavior subclass: #CompositeBoidBehavior
  instanceVariableNames: 
    ' elements '
  classVariableNames: ''
  poolDictionaries: ''   !

BoidBehavior subclass: #SimpleBoidBehavior
  instanceVariableNames: 
    ' name '
  classVariableNames: ''
  poolDictionaries: ''  !

SimpleBoidBehavior subclass: #ActionBehavior
  instanceVariableNames: 
    ' action '
  classVariableNames: ''
  poolDictionaries: ''  !

SimpleBoidBehavior subclass: #FollowNeighbours
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

GenesisBoidsModel subclass: #BoidPart
  instanceVariableNames: 
    ' parent '
  classVariableNames: ''
  poolDictionaries: '' !

BoidPart subclass: #BoidMind
  instanceVariableNames: 
    ' thoughts '
  classVariableNames: ''
  poolDictionaries: ''    !

BoidPart subclass: #BoidPointOfMass
  instanceVariableNames: 
    ' mass position direction speed '
  classVariableNames: ''
  poolDictionaries: ''    !

BoidPointOfMass subclass: #GenesisActorBody
  instanceVariableNames: 
    ' actor motion elapsed '
  classVariableNames: ''
  poolDictionaries: '' !

GenesisBoidsModel subclass: #GenesisBoid
  instanceVariableNames: 
    ' space body mind neighbours '
  classVariableNames: ''
  poolDictionaries: ''  !

GenesisBoid subclass: #Bandouiruka
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

GenesisBoid subclass: #Bot
  instanceVariableNames: 
    ' pathName '
  classVariableNames: ''
  poolDictionaries: ''  !

GenesisBoid subclass: #Plesiosaur
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

GenesisBoid subclass: #Tuna
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

GenesisBoid subclass: #Yodan
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

GenesisSpace subclass: #GenesisBoidsSpace
  instanceVariableNames: 
    ' boids randomizer bounds '
  classVariableNames: ''
  poolDictionaries: ''    !

GenesisSpaceManager subclass: #GenesisBoidsSpaceManager
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

GenesisExtensionCoordinator subclass: #GenesisBoids
  instanceVariableNames: 
    ' selected followSelector scale prototypicalBoids '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants '  !


!GenesisBoidsModel methods !
 
randomizer
	"Returns the randomizer."

	^GenesisRandomNumberGenerator default! !



!BoidBehavior class methods !

empty
	"Returns an empty behavior."

	^CompositeBoidBehavior new! !



!BoidBehavior methods !
   
, aBehavior
	"Returns a behavior representing the receiver and aBehavior."

	^CompositeBoidBehavior with: self with: aBehavior!
  
value: aBoid
	"Evaluates the receiver in aBoid."

	^self implementedBySubclass!
  
value: aBoid value: seconds
	"Evaluates the receiver in aBoid at elapsed seconds."

	^self value: aBoid! !



!CompositeBoidBehavior class methods !
 
with: aBehavior
	"Returns an instance of the receiver with the elements."

	^self new
		add: aBehavior;
		yourself!

with: aBehavior
	with: bBehavior
	"Returns an instance of the receiver with the elements."

	^self new
		add: aBehavior;
		add: bBehavior;
		yourself!
   
with: aBehavior
	with: bBehavior
	with: cBehavior
	"Returns an instance of the receiver with the elements."

	^self new
		add: aBehavior;
		add: bBehavior;
		add: cBehavior;
		yourself!
  
with: aBehavior
	with: bBehavior
	with: cBehavior
	with: dBehavior
	"Returns an instance of the receiver with the elements."

	^self new
		add: aBehavior;
		add: bBehavior;
		add: cBehavior;
		add: dBehavior;
		yourself! !



!CompositeBoidBehavior methods !
   
, aBehavior
	"Returns a behavior representing the receiver and aBehavior."

	self isEmpty ifTrue: [ ^aBehavior ].
	self add: aBehavior.
	^self!

add: anElement
	" Private - Add an element to the receiver. "

	^self elements add: anElement!
   
elements
	" Private - Returns the instance var of the receiver
	 for external manipulation"

	elements isNil ifTrue: [ self initializeElements ].
	^elements!
  
initializeElements
	" Private - Initializes the receiver's elements"

	elements := OrderedCollection new.!
   
isEmpty
	" Returns true if the receiver is empty. "

	^elements size = 0!

printOn: aStream
	"Append the ASCII representation of the receiver to aStream."

	| contents |
	super printOn: aStream.
	aStream space; nextPut: $[.
	contents := self elements.
	contents do: [:each|
		aStream nextPutAll: each name.
		each == contents last ifFalse: [ aStream nextPut: $+ ].
	].
	aStream nextPut: $].!
 
value: aBoid value: seconds
	"Evaluates the receiver in aBoid at elapsed seconds."

	self elements do: [:each| each value: aBoid value: seconds ].! !



!SimpleBoidBehavior class methods !
 
named: aName
	"Returns an instance of the receiver."

	^self new
		name: aName;
		yourself! !



!SimpleBoidBehavior methods !
 
initializeName
	" Private - Initializes the receiver's name"

	name := self species name.!
   
name
    "Returns the instance var of the receiver
     for external manipulation"

	name isNil ifTrue: [ self initializeName ].
    ^name!

name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
printOn: aStream
	"Append the ASCII representation of the receiver to aStream."

	aStream
		nextPutAll: self name;
		space; nextPut: $[.
	super printOn: aStream.
	aStream nextPut: $].! !



!ActionBehavior class methods !

doing: anAction
	"Returns an instance of the receiver."

	^self new
		action: anAction;
		yourself!

forBody: aSelector
	"Returns an instance of the receiver that actuate on the body."

	^(self named: aSelector)
		action: [:aBoid| aBoid body perform: aSelector ];
		yourself!
 
named: aName doing: anAction
	"Returns an instance of the receiver."

	^(self named: aName)
		action: anAction;
		yourself! !



!ActionBehavior methods !
 
action
	"Returns the instance var of the receiver
	 for external manipulation"
	^action!
 
action: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	action := anObject!

value: aBoid
	"Evaluates the receiver in aBoid."

	^self action evaluateWithArguments: (Array with: aBoid)! !



!FollowNeighbours methods !
 
value: aBoid
	"Evaluates the receiver in aBoid."

	| neighbours centre speed |

	neighbours := aBoid neighbours
		select: [:each | aBoid wantsToFollow: each ].
	neighbours isEmpty ifTrue: [ ^self ].

	centre := (neighbours
		inject: 0 into: [:result :boid |
			boid body position + result
		]) / neighbours size.
	speed := (neighbours
		inject: 0 into: [:result :boid |
			boid body speed + result
		]) / neighbours size.

	aBoid body
		tryToTurnTo: centre;
		tryToSetSpeedTo: speed;
		yourself.! !



!BoidPart class methods !

for: aBoid
	"Returns an instance of teh receiver for aBoid."

	^self new
		parent: aBoid;
		yourself! !



!BoidPart methods !
 
animationEnd: seconds
	" Private - An step animation has end.
	The default action is to do nothing.
	This method can be refined by the subclasses. "!

animationStart: seconds
	" Private - The receiver will be part of a step animation.
	The default action is to do nothing.
	This method can be refined by the subclasses. "!
  
birth
	" The life of the boid has started.
	The default action is to do nothing.
	This method can be refined by the subclasses."!

boid
	"Returns the boid of the receiver."

	^self parent!

clone
	"Returns a clone of the receiver."

	^self copy initializeClone!
  
cloneFor: aParent
	"Returns a clone of the receiver in aParent."

	| aClone |
	aClone := self clone.
	^aClone notNil ifTrue: [
		aClone parent: aParent; yourself
	]!

highlight
	"Perform highlight action of the receiver.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
 
initializeClone
	" Private - Initializes the receiver as a clone.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
 
initializePrototype
	" Private - Initialize the receiver as a prototipycal instance.
	The default action is to do nothing.
	MUST return the receiver or nil if invalid.
	This method can be refined by the subclasses."!

kill
	" The life of the boid has ended.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
   
parent
	"Returns the instance var of the receiver
	 for external manipulation"
	^parent!
 
parent: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	parent := anObject!

randomize
	"Randomize the receiver.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
   
space
	"Returns the space of the receiver."

	^self boid space!
  
step: seconds for: aBoid
	"Perform a simulation step for aBoid.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
   
world
	"Returns the world of the receiver"

	^self space world! !



!BoidMind class methods !
   
for: aParent with: aBehavior
	"Returns an instance of the receiver with aBehavior."

	^(self for: aParent)
		remember: aBehavior;
		yourself! !



!BoidMind methods !
 
forget: aBehavior
	"Forget a Behavior if present."

	self thoughts remove: aBehavior ifAbsent: []!
   
initializeClone
	" Private - Initializes the receiver as a clone. "

	super initializeClone.
	thoughts notNil ifTrue: [
		thoughts := self thoughts copy
	].!
 
initializeThoughts
	" Private - Initializes the receiver's thoughts"

	thoughts := OrderedCollection new.!
   
remember: aBehavior
	"Remember a Behavior."

	self thoughts add: aBehavior.!
 
step: seconds for: aBoid
	"Perform a simulation step for aBoid."

	self thoughts do: [:thought|
		thought value: aBoid value: seconds
	]!
  
thoughts
	"Returns the instance var of the receiver
	 for external manipulation"

	thoughts isNil ifTrue: [ self initializeThoughts ].
	^thoughts! !



!BoidPointOfMass methods !
 
advance
	"Advance the receiver."

	self speed = 0 ifTrue: [ ^self ].
	self tryToMoveTo: (
		self position
			add: self direction
			scaledBy: speed).!
   
densityFactor
	" Private - Returns the density factor of the receiver. "

	^self boid densityFactor!
 
direction
	"Returns the instance var of the receiver
	 for external manipulation"

	direction isNil ifTrue: [ self initializeDirection ].
	^direction!
 
direction: aGenesisVector3D
	"Sets the instance var of the receiver."

	direction := aGenesisVector3D !
  
gravityFactor
	" Private - Returns the gravity factor of the receiver. "

	^self boid isAffectedByGravity
	ifTrue: [ 9.8 ]
	ifFalse: [ 1 ]!

highlight
	"Perform highlight action of the receiver."

	super highlight.
	self world drawVolume:
		(Notifier isShiftKeyDown
		ifTrue: [ self boid neighboursVolume ]
		ifFalse: [ self boundingBox ]).!
 
inertia
	"Returns the current inertia vector."

	^self direction * self mass!

inertia: aVector
	"Sets the current inertia vector."

	self speed: aVector length.
	aVector length = 0
	ifTrue: [ self direction: self direction negated ]
	ifFalse: [ self direction: aVector copy normalize ].!
 
initializeDirection
	" Private - Initializes the receiver's direction"

	self direction: (self space randomDirectionFor: self boid).!

initializeMass
	" Private - Initializes the receiver's mass"

	| diagonal volume |
	diagonal := self boundingBox diagonal.
	volume := diagonal x * diagonal y * diagonal z.
	self mass: volume
		* self densityFactor
		/ self gravityFactor.!
  
initializePosition
	" Private - Initializes the receiver's position"

	self position: (self space randomPositionFor: self boid).!

initializeSpeed
	" Private - Initializes the receiver's speed"

	self speed:
			self maximumSpeed - self minimumSpeed
			* self space randomizer next
			+ self minimumSpeed.!

mass
	"Returns the instance var of the receiver
	 for external manipulation"

	mass isNil ifTrue: [ self initializeMass ].
	^mass!
 
mass: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	mass := anObject!

maximumSpeed
	"Returns the receiver's maximumSpeed."

	^37!
  
minimumSpeed
	"Returns the receiver's minimumSpeed."

	^0!
   
normalSpeed
	"Returns the receiver's normalSpeed."

	^self maximumSpeed + self minimumSpeed / 2!
 
position
	"Returns the instance var of the receiver
	 for external manipulation"

	position isNil ifTrue: [ self initializePosition ].
	^position!
 
position: aGenesisVector3D
	"Sets the instance var of the receiver with anObject."

	position := aGenesisVector3D!
   
randomize
	"Randomize the receiver's properties."

	super randomize.
	self
		position: nil;
		direction: nil;
		speed: nil;
		yourself.!

speed
	"Returns the instance var of the receiver
	 for external manipulation"

	speed isNil ifTrue: [ self initializeSpeed ].
	^speed!
 
speed: aNumber
	"Sets the speed of the receiver."

	speed := aNumber.
	aNumber notNil ifTrue: [
		speed := (aNumber
			max: self minimumSpeed)
			min: self maximumSpeed.
	].!
  
speedPercent
	"Returns the speed of the receiver as an integer percent."

	^self speed - self minimumSpeed * 100 // (self maximumSpeed - self minimumSpeed)!
 
tryToMoveTo: location
	" Private - Try to move the receiver to location from current position. "

	self position: location.!
 
tryToSetSpeedTo: aSpeed
	"The receiver will try to set the speed to aSpeed."

	| delta |
	delta := aSpeed - self speed.
	delta := delta / 10.
	self speed: self speed + delta.
	!

tryToTurnTo: destination
	"The receiver will try to turn to destination."

	| delta |
	delta := destination - self position.
	delta isZero ifTrue: [ ^self ].
	delta normalize.
	delta := delta / 5. "we MUST consider speed&mass to restrict turning."
	self direction: (self direction + delta) normalize.
	!

volume
	" Private - Returns the receiver's volume (as a magnitude). "

	^self implementedBySubclass!
 
weight
	"Returns the weight of the receiver (as a force)."

	^GenesisVector3D
		x: 0 y: self mass * self gravityFactor negated z: 0!

xForm
	" Private - Returns the current transform of the receiver. "

	| origin corner delta |
	origin := self position.
	delta := self speed abs.
	delta = 0 ifTrue: [ delta := 1 ].
	corner := origin add: self direction scaledBy: delta.
	origin = corner ifTrue: [ "Invalid direction."
		^GenesisXForm new translation: origin
	].
	^origin xFormPointingTo: corner at: origin! !



!GenesisActorBody class methods !
  
constructEventsTriggered
	"Private - Answer the set of events that instances of the receiver can trigger."

	^super constructEventsTriggered
		add: #motionAtEnd;
		add: #fallingDown:;
		add: #falling;
		yourself! !



!GenesisActorBody methods !

actor
	"Returns the instance var of the receiver
	 for external manipulation"
	^actor!
   
actor: aGenesisActor
	"Sets the instance var of the receiver."

	actor := aGenesisActor.!

actorPathName
	" Private - Returns the receiver's actor path name. "

	^self boid actorPathName!
 
animationStart: seconds
	" Private - The receiver will be part of a step animation. "

	super animationStart: seconds.
	self updateExtBox.!
 
applyGravity
	" Private - Apply gravity force to the receiver. "

	| start stop mins maxs box point delta collision |
	self boid isAffectedByGravity ifFalse: [ ^self ].
	start := self position.
	box := self boundingBox.
	mins := box origin - start.
	maxs := box corner - start.
	delta := GenesisVector3D x: 0 y: maxs y // 2 z: 0.
	stop := self weight / 5 + start.
	stop y > start y ifTrue: [ ^self ].

	collision := self world collision.
	collision
		"mins: mins; maxs: maxs;"
		front: start; back: stop;
		solidClip; collideModels;
		yourself.

	collision success
	ifTrue: [ point := collision impact + delta. ]
	ifFalse: [ "falling..."
		point := stop.
		self
			triggerEvent: #falling;
			triggerEvent: #fallingDown: with: stop.
	].

	self position: point.!
   
birth
	" The life of the boid has started."

	super birth.
	actor
		scale: self scaleFactor;
		extBox: self defaultExtBox;
		yourself.!
  
boundingBox
	"Returns the receiver's boundingBox."

	^self actor boundingBox!

defaultExtBox
	" Private - Returns the default extensionBox. "

	^self boid defaultExtBox!
   
direction: aGenesisVector3D
	"Sets the instance var of the receiver."

	super direction: aGenesisVector3D.

	(direction notNil and: [ self boid isAffectedByGravity ])
	ifTrue: [ direction y: (0 min: 0.5) ].!
   
handleCollision: collision movingTo: location
	" Private - The receiver has collided to another object when trying to move to location.
	The default action is to delegate behavior on space. "

	self space
		handleCollision: collision
		moving: self boid
		to: location.!
   
hasMotions
	" Returns true if the receiver has any motion. "

	^actor notNil
		and: [ actor isValid
		and: [ actor hasMotions ] ]!
 
height
	"Returns the receiver's height."

	^self boundingBox diagonal y abs!
 
initializeActor
	" Private - Initializes the receiver's actor. "

	elapsed := 0.
	self actor: (GenesisActor fromPathName: self actorPathName).
	(actor isNil or: [ actor isValid not ]) ifTrue: [
		^self error: 'Actor not found ', self actorPathName
	].!
 
initializeClone
	" Private - Initializes the receiver as a clone."

	super initializeClone.
	actor notNil ifTrue: [ self actor: actor clone ].
	motion notNil ifTrue: [ self motionName: self motion name ].!
  
initializeMotion
	" Private - Initializes the receiver's motion"

	self motionName: self boid motionName!

initializePrototype
	" Private - Initializes the receiver as a prototipycal instance.
	MUST return the receiver or nil if invalid."

	super initializePrototype.
	[self initializeActor ] on: Error do: [ ^nil ].
	(actor isNil or: [ actor isValid not ]) ifTrue: [ ^nil ].
	self motion. "try to initialize with default motion."!
 
kill
	" The life of the boid has ended."

	super kill.
	self world removeActor: self actor.!

motion
	"Returns the instance var of the receiver
	 for external manipulation"

	motion isNil ifTrue: [ self initializeMotion ].
	^motion!
 
motion: aMotion
	"Sets the receiver's motion."

	aMotion isString ifTrue: [ ^self motionName: aMotion ].
	motion := aMotion!

motionName: aName
	" Initializes the receiver's motion with one named aName (if present). "

	(motion notNil and: [ motion name = aName ]) ifTrue: [ ^self ].
	self hasMotions
	ifTrue: [
		self motion: (actor
			motionNamed: (aName isNil
				ifTrue: [ 'Idle' ]
				ifFalse: [ aName ])
			ifAbsent: [ actor firstMotion ]).
	]!
 
motionNames
	" Returns the posible motion names. "

	^actor motionNames!
 
radix
	"Returns the receiver's radix (used during collision computations)."

	^self boundingBox diagonal / 2!

randomize
	"Randomize the receiver's properties."

	actor isNil ifTrue: [ ^self ].
	super randomize.!
   
resetMotion
	"Reset the receiver's motion."

	self motion: nil;motion!
   
scaleFactor
	" Private - Returns the scale factor to be used in receiver's scaling. "

	^self boid scaleFactor!
  
setPose: seconds
	" Private - Set the receiver's pose. "

	| timeExtents width poseXForm |
	actor isNil ifTrue: [ ^self ].
	poseXForm := self boid adjustXForm: self xForm.
	motion isNil | elapsed isNil
		ifTrue: [ ^actor clearPose: poseXForm ].
	timeExtents := self motion timeExtents.
	width := timeExtents last - timeExtents first.
	elapsed :=
		width = 0	ifTrue: [ 0 ]
		ifFalse: [ elapsed + seconds ].
	elapsed <= width
	ifTrue: [ elapsed := elapsed + timeExtents first ]
	ifFalse: [
		self triggerEvent: #motionAtEnd.
		elapsed := self motion timeExtents first
	].
	self actor
		setPoseTo: self motion
		time: elapsed
		transform: poseXForm.!
   
step: seconds for: aBoid
	"Perform a simulation step for aBoid."

	super step: seconds for: aBoid.
	self
		applyGravity;
		setPose: seconds.!
 
tryToMoveTo: location
	" Private - Try to move the receiver to location from current position. "

	| collision minsAndMaxs |
	location isNil ifTrue: [ ^self ].
	collision := self world collision.
	collision
		front: self position;
		back: location;
		solidClip; collideAll;
		yourself.
	collision success
	ifTrue: [
		^self
			handleCollision: collision
			movingTo: location
	].
	self position: location.!
 
updateExtBox
	" Private - Update the collision extensionBox. "

	| box |
	box := self boundingBox.
	box := box translate: self position negated.
	actor extBox: box.!
 
volume
	" Private - Returns the receiver's volume (as a magnitude). "

	| diagonal volume |
	diagonal := self boundingBox diagonal.
	^diagonal x * diagonal y * diagonal z! !



!GenesisBoid class methods !
  
actorsRepository
	" Private - Returns the actor repository. "

	^Directory pathName: self pathForActors!
 
defaultBehavior
	"Returns the default behavior for the receiver's specimens.
	The default answer is an empty behavior.
	This method can be refined by the subclasses."

	^BoidBehavior empty!
  
defaultBoidBehavior
	"Returns the default behavior for boids."

	^FollowNeighbours new, self stupidBehavior!
 
pathFor: species
	" Private - Returns the path in the actor repository for body of species. "

	^self pathForActors, species asString, '.act'!
   
pathForActors
	" Private - Returns the path of the actor's repository. "

	^Disk pathName, '\Actors\'!
   
prototypesFor: aSpace
	"Returns a collection of specimens of the receiver."

	| result |
	result := OrderedCollection"Set" new.
	self allSubclasses do: [:each |
		result addAll: (each specimensFor: aSpace)
	].
	^result asArray!
 
specimenFor: aSpace
	"Returns a prototipycal instance of the receiver.
	This method will try to create a prototipycal instance of the receiver,
	  returns the instance or nil if it can't be created."

	^self new
		space: aSpace;
		initializePrototype!
  
specimensFor: aSpace
	"Returns the prototipycal instances of the receiver.
	By default returns anArray with the default specimen (if present).
	This method can be refined by the subclasses."

	^(Array with: (self specimenFor: aSpace)) select: [:each| each notNil ]!
  
stupidBehavior
	" Returns the stupid behavior (always go forward). "

	^ ActionBehavior forBody: #advance! !



!GenesisBoid methods !
   
actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^self implementedBySubclass!
 
adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly.
	Default action is to do nothing.
	This method can be refined by the subclasses.
	WARNING: MUST return the modified transform. "

	^aXForm!
   
animationEnd: seconds
	" Private - An step animation has end.
	The default action is to delegate on the receiver's parts.
	This method can be refined by the subclasses. "

	mind animationEnd: seconds.
	body animationEnd: seconds.!

animationStart: seconds
	" Private - The receiver will be part of a step animation.
	The default action is to clear animation caches &  delegate on the receiver's parts.
	This method can be refined by the subclasses. "

	neighbours :=
		nil.

	mind animationStart: seconds.
	body animationStart: seconds.!
  
birth
	"Life of the receiver starts."

	self body birth.
	self mind birth.
	self body
		when: #motionAtEnd do: [ self resetMotion ];
		yourself.!

body
	"Returns the instance var of the receiver
	 for external manipulation"

	body isNil ifTrue: [ self initializeBody ].
	^body!
 
body: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	body := anObject!

bodyPointer
	" Private,CollisionDetection - Returns a private actor's body pointer. "

	^self body actor pointer!

boundingBox
	"Returns the current bounding box."

	^self body boundingBox!
   
clone
	"Returns a clone of the receiver."

	^self copy initializeClone!
  
defaultDiagonal
	" Private - Returns the default diagonal.
	The default answer is a 10 point width volume.
	This method can be refined by the subclasses.

	The compute this value you can build an instance
		with default values and get body boundingBox's
		diagonal in horizontal direction. "

	^GenesisVector3D x: 10 y: 10 z: 10!
  
defaultExtBox
	" Private - Returns the default extensionBox.
	The default answer is a volume from diagonal.
	This method can be refined by the subclasses.

	The compute this value you can build an instance
		with default values and get body boundingBox's
		diagonal in horizontal direction.
	"

	| radix |
	radix := self defaultDiagonal * self scaleFactor // 2.
	^GenesisExtBox origin: radix negated corner: radix!
  
defaultMotionName
	" Private - Returns the default motion name.
	The default answer is the name of the 'Idle' motion.
	This method can be refined by the subclasses. "

	^'Idle'!
  
densityFactor
	"Must return the density factor (to compute aproximate mass from volume)."

	^0.12e-3
"	*Empirical value*
	Computed from human-like character stand-up with open arms.

	| diagonal volume scale |
	scale := 109 / 160.
	diagonal := GenesisVector3D from: #( 160 180 90 ).
	diagonal := diagonal  * scale.
	volume := diagonal x * diagonal y * diagonal z.
	98 / volume

	aprox. weight = 98kg.
"!
  
doOneOf: motions
	" Private - Set the receiver's motion to one of motions. "

	^self doOneOf: motions in: 5
		 "1/5 provability to do one of the requested motions."!
   
doOneOf: motions in: dimension
	" Private - Set the receiver's motion to one of motions. "

	| random success |
	random := (self randomizer next * dimension) truncated.
	success := (random between: 1 and: motions size).
	self motion: (success ifTrue: [ motions at: random ]).
	^success!
   
hardImpact: aCollision
	"The receiver's has impacted to a really hard thing.
	The default action is to do nothing (the world[space] will reflect our body from the colission surface).
	This method can be refined by the subclasses."!
  
highlight
	"Perform highlight action of the receiver."

	self mind highlight.
	self body highlight.!

impact: aBoid
	"The receiver's has impacted to aBoid.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
 
impactedBy: aBoid
	"The receiver's has been impacted by aBoid.
	The default action is to transfer cinetics.
	This method can be refined by the subclasses."

"
	self body direction:
		(self body direction + aBoid body direction / 2) normalize
"
	self body speed: aBoid body speed + self body speed.
!
   
initializeBody
	" Private - Initializes the receiver's body"

	body := GenesisActorBody for: self.!
  
initializeClone
	" Private - Initializes the receiver as a clone."

	body notNil ifTrue: [ body := body cloneFor: self ].
	mind notNil ifTrue: [ mind := mind cloneFor: self ].!

initializeMind
	" Private - Initializes the receiver's mind"

	mind := BoidMind for: self with: self species defaultBehavior.!
   
initializeNeighbours
	" Private - Initializes the receiver's neighbours"

	neighbours := (self space
		boidsIn: self neighboursVolume)
		remove: self ifAbsent: [];
		yourself!
   
initializePrototype
	" Private - Initializes the receiver as a prototipycal instance.
	MUST return the receiver or nil if invalid."

	(self body initializePrototype isNil
	or: [ self mind initializePrototype isNil ])
	ifTrue: [ ^nil ].!
  
isAffectedByGravity
	"Must return true if the receiver is affected by gravity.
	The default answer is false.
	This method can be refined by the subclasses."

	^false!
 
kill
	"Kill the receiver."

	self mind kill.
	self body kill.!
  
mind
	"Returns the instance var of the receiver
	 for external manipulation"

	mind isNil ifTrue: [ self initializeMind ].
	^mind!
 
mind: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	mind := anObject!

motion: aMotion
	" Private - Set the receiver's motion. "

	self body motion: aMotion!
   
motionName
	" Private - Returns the name of default motion. "

	^self defaultMotionName!
 
neighbours
	"Returns the instance var of the receiver
	 for external manipulation"

	neighbours isNil ifTrue: [ self initializeNeighbours ].
	^neighbours!
 
neighboursVolume
	" Private - Returns the volume used to detect neighbours of the receiver. "

	| volume delta |
	volume := self body boundingBox asVolume.
	volume := volume expandBy: volume diagonal * 5 / 3.
	delta := GenesisVector3D zero
		add: self body direction
		scaledBy: volume diagonal length / 5.
	volume := volume translateBy: delta.
	^volume
!
  
pathFor: species
	" Private - Returns the path in the actor repository for body of species. "

	^self class pathFor: species!

printOn: aStream
	"Append the ASCII representation of the receiver to aStream."

	aStream
		nextPutAll: self actorPathName fileNameLessPath fileName;
		space; nextPut: $[.
	super printOn: aStream.
	aStream nextPut: $].!
  
randomize
	"Randomize the receiver's properties."

	self body randomize.
	self mind randomize.!
 
resetMotion
	" Private - Reset the receiver's motion. "

	self motion: nil.!
 
scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling.
	The default answer is no scale.
	This method can be refined by the subclasses. "

	^1!
   
select
	"Notifiy the receiver that it is the 'selected' object.
	The default action is to do nothing.
	This method can be refined by the subclasses."!
   
space
	"Returns the instance var of the receiver
	 for external manipulation"
	^space!
   
space: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	space := anObject!
  
think: seconds
	" Private - The receiver must think what he want to do during move time. "

	self mind step: seconds for: self.!
 
unselect
	"Notifiy the receiver that has been un-selected.
	The default action is to do nothing.
	This method can be refined by the subclasses."!

wantsToFollow: aBoid
	" Returns true if the receiver wants to follow aBoid.
	By default Boids want to fly in it flock. "

	^aBoid isKindOf: self species!
   
work: seconds
	" Private - The receiver can do physical movements with it's body. "

	self body step: seconds for: self.! !



!Bandouiruka class methods !
  
defaultBehavior
	"Returns the default behavior for the receiver's specimens."

	^self defaultBoidBehavior! !



!Bandouiruka methods !
   
actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^Disk pathName, '\Actors\Bandouiruka.act'!
   
adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly. "

	| delta |
	delta := Float pi / 2 negated.
	^aXForm * (
		GenesisXForm identity
			rotationX: delta;
			rotateY: delta;
			yourself)!
   
scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling. "

	^30! !



!Bot class methods !
  
defaultBehavior
	"Returns the default behavior for the receiver's specimens."

	^self defaultBoidBehavior!
   
specimensFor: aSpace
	"Returns the prototipycal instances of the receiver."

	| directory |
	directory := self actorsRepository.
	^(directory filesNamed: 'Bot_*.act') collect: [:fileName|
			self new
				space: aSpace;
				pathName: directory drivePathName,'\',fileName;
				initializePrototype
		]! !



!Bot methods !
   
actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^self pathName!
  
adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly. "

	| position delta steps |
	"*debug*
	steps := 10.
	delta := Time now asSeconds \\ steps * Float pi * 2 / steps.
	"
	position := aXForm position.
	^aXForm
		translation: 0;
		rotationX: Float pi * 3 / 2;
		rotateY: Float pi / 2;
		"rotateY: delta;"
		translation: position;
		yourself!
  
birth
	"Life of the receiver starts."

	super birth.
	self motion: 'start_again'.!
  
defaultDiagonal
	" Private - Returns the default diagonal. "

	^GenesisVector3D from: #( 87 77 63 )!
 
hardImpact: aCollision
	"The receiver's has impacted to a really hard thing."

	super hardImpact: aCollision.
	" self motion: 'crash'. "!
   
impact: aBoid
	"The receiver's has impacted to aBoid."

	super impact: aBoid.
	self motion: 'board_brake'.!
 
impactedBy: aBoid
	"The receiver's has been impacted by aBoid."

	super impactedBy: aBoid.
	self motion: 'get_a_hit'.!
  
motionFromSpeed
	" Private - Returns the receiver's motion name extracted from body speed. "

	| percent |
	percent := self body speedPercent.
	percent > 70 ifTrue: [ ^'hover_fast' ].
	percent < 3 ifTrue: [ ^'wait_to_start_again' ].
	percent < 20 ifTrue: [ ^'idle' ].
	^'hover_slow'!
 
normalMotions
	" Private - Returns the receiver's motion in 'normal' state. "

	^#(
			'trick_1' 'trick_2' 'trick_3' 'trick_4'
			'falling' 'jump_low' 'jump_high'
	)!

pathName
	"Returns the instance var of the receiver
	 for external manipulation"
	^pathName!
 
pathName: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	pathName := anObject!

resetMotion
	" Private - Reset the receiver's motion. "

	(self doOneOf: self normalMotions)
	ifFalse: [ self motion: self motionFromSpeed ].!
  
scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling. "

	^1.5!
   
select
	"Notifiy the receiver that it is the 'selected' object."

	super select.
	self motion: 'board_brake'.!
  
unselect
	"Notifiy the receiver that has been un-selected."

	super unselect.
	self motion: 'the_end'.! !



!Plesiosaur class methods !

defaultBehavior
	"Returns the default behavior for the receiver's specimens."

	^self defaultBoidBehavior! !



!Plesiosaur methods !

actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^Disk pathName, '\Actors\Plesio.act'!

adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly. "

	| delta steps |
	"*debug*
	steps := 10.
	delta := Time now asSeconds \\ steps * Float pi * 2 / steps.
	delta displayAt: 10@10.
	"
	^aXForm * (
		GenesisXForm identity
			rotationX: Float pi / 2 negated;
			yourself)!

defaultDiagonal
	" Private - Returns the default diagonal. "

	^GenesisVector3D from: #( 710 107 400 )!
  
scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling. "

	^1 / 10 * 3! !



!Tuna class methods !
 
defaultBehavior
	"Returns the default behavior for the receiver's specimens."

	^self defaultBoidBehavior! !



!Tuna methods !
  
actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^Disk pathName, '\Actors\Tuna.act'!
  
adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly. "

	| delta steps |
	"*debug*
	steps := 10.
	delta := Time now asSeconds \\ steps * Float pi * 2 / steps.
	delta displayAt: 10@10.
	"
	^aXForm * (
		GenesisXForm identity
			rotationX: Float pi / 2 negated;
			rotateY: Float pi;
			yourself)!
 
defaultDiagonal
	" Private - Returns the default diagonal. "

	^GenesisVector3D from: #( 13 37 5 )!
  
scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling. "

	^2! !



!Yodan class methods !
 
defaultBehavior
	"Returns the default behavior for the receiver's specimens."

	^self defaultBoidBehavior! !



!Yodan methods !
 
actorPathName
	" Private,Body - Returns the receiver's actor path name. "

	^Disk pathName, '\Actors\Yodan.act'!
 
adjustXForm: aXForm
	" Private - Adjust a transform to show actor properly. "

	| position delta steps |
	"*debug*
	steps := 10.
	delta := Time now asSeconds \\ steps * Float pi * 2 / steps.
	"
	position := aXForm position.
	"
	body world
		drawBoxFrom: position - #(50 2 50 )
		to: position + #(50 2 50 ).
	"
	position y: position y - 70.

	^aXForm
		translation: 0;
		"rotationY: Float pi * 1 / 2;"
		rotateY: Float pi;
		translation: position;
		yourself!
 
defaultDiagonal
	" Private - Returns the default diagonal. "

	^GenesisVector3D from: #( 135 70 68 )!

defaultMotionName
	" Private - Returns the default motion name. "

	^'Crawl'!

hardImpact: aCollision
	"The receiver's has impacted to a really hard thing."

	super hardImpact: aCollision.
	self motion: 'Jump'.!

isAffectedByGravity
	"Must return true if the receiver is affected by gravity."

	^true!
 
motionFromSpeed
	" Private - Returns the receiver's motion name extracted from body speed. "

	| percent |
	percent := self body speedPercent.
	percent > 70 ifTrue: [ ^'Run' ].
	percent < 3 ifTrue: [ ^'Shoot' ].
	percent < 20 ifTrue: [ ^'Crawl' ].
	^'Walk'!
   
resetMotion
	" Private - Reset the receiver's motion. "

	self motion: self motionFromSpeed.!

scaleFactor
	" Private,Body - Returns the scale factor to be used in receiver's scaling. "

	^1.5! !



!GenesisBoidsSpace methods !
 
addBoid: aBoid
	" Private - Spawn aBoid in the space. "

	self world addActor: aBoid body actor.
	self boids add: aBoid.
	aBoid birth.!

addModelsToWorld
	" Private - Add the receiver's model to world. "!

boids
	"Returns the instance var of the receiver
	 for external manipulation"

	boids isNil ifTrue: [ self initializeBoids ].
	^boids!
 
boids: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	boids := anObject!
  
boidsIn: aBox
	"Returns the boids in the receiver contained in aBox."

	^self boids select: [:each| aBox containsPoint: each body position ]!

bouncingCollision: aCollision moving: aBoid to: newLocation
	" Private - Solve aCollision with bouncing."

	| reflect normal direction |
	normal := aCollision normal.
	direction := aBoid body direction.
	direction :=  direction + normal.
	direction isZero
		ifTrue: [ direction := aBoid body direction negated ]
		ifFalse: [ direction normalize ].
	aBoid body
		direction: direction;
		" position: aCollision impact; "
		yourself.
	aBoid hardImpact: aCollision.!

bounds
	"Returns the instance var of the receiver
	 for external manipulation"

	bounds isNil ifTrue: [ self initializeBounds ].
	^bounds!
 
bounds: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	bounds := anObject!

handleCollision: aCollision moving: aBoid to: newLocation
	"Handle aCollision occurred to aBoid while trying to move to newLocation."

	| thing |
	thing := aCollision actor.
	thing notNil
	ifTrue: [ "Collision with another actor."
		^self
			impactFrom: aBoid
			to: (self privateBoid: thing)
			at: aCollision impact
	].

	"Collision with aModel/Wall."
	^self bouncingCollision: aCollision moving: aBoid to: newLocation
"
	^self slidingCollision: aCollision moving: aBoid to: newLocation
"

	" *obsolete teleport to the opposite wall*
	aBoid body position: (self
		positionFor: aBoid
		at: newLocation)
	"!
  
impactFrom: aBoid to: bBoid at: impact
	" Private - Notify aBoid that impacted bBoid."

	| impactA impactB sum aBody bBody |
	aBody := aBoid body.
	bBody := bBoid body.
	impactA := aBody inertia.
	impactB := bBody inertia.
	sum := impactA + impactB.
	aBody inertia: sum + impactB.
	bBody inertia: sum + impactA.

	aBoid impact: bBoid.
	bBoid notNil ifTrue: [ bBoid impactedBy: aBoid ].!
 
initializeBoids
	" Private - Initializes the receiver's boids"

	boids := OrderedCollection new.!

initializeBounds
	" Private - Initializes the receiver's bounds"


	| collision xForm distance points origin corner |
	distance := 7000. "maximum spected world extent."
	xForm := GenesisXForm identity.
	"xForm translateY: 10.  place the bBox lookup point"
	collision := self world collision.
	collision
		front: xForm position;
		solidClip; collideModelsWithoutSubmodels;
		yourself.
	points := #(
		(1 0 0) (-1 0 0)
		(0 1 0) (0 -1 0)
		(0 0 1) (0 0 -1)
	) collect: [:ray|
		collision
			back: (xForm position
				add: (GenesisVector3D from: ray)
				scaledBy: distance).
		collision success
		ifTrue: [ collision impact copy ]
	].
	origin := GenesisVector3D zero.
	corner := GenesisVector3D zero.
	points do: [:each|
		origin
			x: (origin x min: each x);
			y: (origin y min: each y);
			z: (origin z min: each z);
			yourself.
		corner
			x: (corner x max: each x);
			y: (corner y max: each y);
			z: (corner z max: each z);
			yourself.
	].
	self bounds:
		(GenesisVolume
			origin: origin
			corner: corner)!
   
initializeRandomizer
	" Private - Initializes the receiver's randomizer"

	randomizer := GenesisRandomNumberGenerator new.!
  
positionFor: aBoid at: desiredLocation
	" Private - Returns a valid position for aBoid trying to stay at desiredLocation."

	| x y z min max gap destination |

	(self bounds containsPoint: desiredLocation)
	ifTrue: [ ^desiredLocation ].

	"teleport the boid to the opposite limit if desiredLocation is out of space."
	gap := aBoid body radix + 5.
	min := self bounds origin + gap.
	max := self bounds corner - gap.
	x := (desiredLocation x between: min x and: max x)
		ifTrue: [ desiredLocation x ]
		ifFalse: [
			desiredLocation x <= min x
			ifTrue: [ max x ]
			ifFalse: [ min x ].
		].
	y := (desiredLocation y between: min y and: max y)
		ifTrue: [ desiredLocation y ]
		ifFalse: [
			desiredLocation y <= min y
			ifTrue: [ max y ]
			ifFalse: [ min y ].
		].
	z := (desiredLocation z between: min z and: max z)
		ifTrue: [ desiredLocation z ]
		ifFalse: [
			desiredLocation z <= min z
			ifTrue: [ max z ]
			ifFalse: [ min z ].
		].
	destination := GenesisVector3D x: x y: y z: z.

	(self bounds containsPoint: destination)
	ifFalse: [ ^self error: 'Computation failure.' ].

	^destination!
  
privateBoid: aGeActor
	" Private - Returns the boid at geActor (or nil)."

	^(aGeActor notNil and: [ aGeActor isValid ])
	ifTrue: [
		self boids
			detect: [:one| one bodyPointer contents = aGeActor contents ]
			ifNone: [ ^nil ]
	]!
   
randomDirectionFor: aBoid
	"Returns a valid random direction for aBoid in the receiver."

	| offset |
	offset := #(1 1 1)
		collect: [:each| self randomizer next * 2 - 1 * each ].
	offset := GenesisVector3D from: offset.
	(offset x <0 and: [ offset y <0 and: [ offset z < 0 ]])
	ifTrue: [ offset x: offset x negated ].
	offset normalize.
	^offset!
   
randomizer
	"Returns the instance var of the receiver
	 for external manipulation"

	randomizer isNil ifTrue: [ self initializeRandomizer ].
	^randomizer!
 
randomizer: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	randomizer := anObject!

randomPositionFor: aBoid
	"Returns a valid random position for aBoid in the receiver."

	| offset |
	offset := (self bounds diagonal / 2 - 70"aBoid body radix") values
		collect: [:each| (self randomizer next - 0.5 * each )
			truncateTo: GenesisMeasure minimumScale ].
	^(GenesisVector3D from: offset) + self bounds center!
 
removeBoid: aBoid
	" Private - Spawn aBoid in the space. "

	aBoid kill.
	self boids remove: aBoid.!

slidingCollision: aCollision moving: aBoid to: newLocation
	" Private - Solve aCollision with sliding."

	| reflect normal direction |
	normal := aCollision normal.
	direction := aBoid body direction.
	reflect := normal * (direction dot: normal) negated.
	direction := direction + reflect.
	direction isZero
		ifTrue: [ direction := aBoid body direction negated ]
		ifFalse: [ direction normalize ].
	aBoid body
		direction: direction;
		position: aCollision impact;
		yourself.!
   
spawnModels
	" Private - Spawn the receiver's models from current world.
	Must return a collection with spawn models."

	^#()!
  
stepBoids: seconds
	" Private - Step the receiver's boids. "

	self boids
		do: [:each| each animationStart: seconds ];
		do: [:each| each think: seconds ];
		do: [:each| each work: seconds ];
		do: [:each| each animationEnd: seconds ];
		yourself.!
   
volume
	"Returns the volume of the receiver."

	| diagonal |
	diagonal := self bounds diagonal.
	^diagonal x * diagonal y * diagonal z! !



!GenesisBoidsSpaceManager methods !
   
classForSpaces
	" Private - Returns the class to use for creating the receiver's spaces. "

	^GenesisBoidsSpace! !



!GenesisBoids methods !

appendSpawn: count items: prototypes to: aMenu
	" Private - Append spawn actions to aMenu."

	| anAction |
	prototypes do: [:option|
		anAction := Message
				receiver: self
				selector: #spawn:cloneOf:
				arguments: (Array with: count with: option).
		aMenu appendItem: option printString action: anAction.
	].!

boids
	"Returns the current boids."

	^self space boids!
 
boidsMenu
	" Private - Returns the boids menu. "

	| menu |
	menu := Menu new
		owner: self;
		title: '&Boids';
		appendSubMenu: self spawnMenu;
		appendItem: '&randomize' selector: #randomizeBoids;
		appendSeparator;
		appendItem: 'select i&t' selector: #detectSelected;
		appendItem: '&clear selected' selector: #unselect;
		appendSubMenu: self selectedMenu;
		appendSeparator;
		appendItem: 'insp&ect this' selector: #inspectIt;
		appendItem: '&inspect Boids' selector: #inspectBoids;
		appendItem: 'inspect S&pace' selector: #inspectSpace;
		appendSeparator;
		appendItem: 're&Draw' selector: #update;
		appendSubMenu: self trackingMenu;
		yourself.
	^menu!
  
boidUnderCursor
	" Private - Returns the boid under cursor (or nil). "

	| rayStart rayEnd direction collision point maxs |
	self world isNil ifTrue: [ ^nil ].
	point := pane mouseLocation.
	pane pen
		place: point;
		circle: 10; circle: 15;
		circle: 20; circle: 25;
		go: 25;go: -50; go:25;
		turn: 90;go: 25;go: -50;
		yourself.
	direction := self camera screenToWorld: point.
	rayStart := self navigator position.
	rayEnd := rayStart
		add: direction
		scaledBy: 1500. "detection power"
	maxs := GenesisVector3D from: 70.

	collision := self world collision.
	collision
		mins: maxs negated;
		maxs: maxs;
		front: rayStart;
		back: rayEnd;
		solidClip; collideAll"collideActors";
		yourself.
	collision success ifFalse: [
		self warning: 'Nothing has been detected under cursor.'.
		^nil
	].
	collision actor isNil ifTrue: [
		self warning: 'No Boid detected under cursor.'.
		^nil
	].

	^self space privateBoid: collision actor!
 
button1Moved
	" Private - The left mouse button has been pressed and is moving. "

	super button1Moved.

	self followMouse.!
   
characterMacros
	" Private - Return the character macro table. "

	^#(
	( $^	incrementScale )		( $>	incrementScale )
	( $v	decrementScale )	( $<	decrementScale )
	), super characterMacros!
  
clearPrototypes
	" Private - Clear the catched prototypical Boid specimens. "

	prototypicalBoids := nil.!
   
decrementScale
	" Private - Decrement the scale factor. "

	self scale: self scale - 0.5!

detectSelected
	" Private - Follow the boid under cursor. "

	self isValid ifTrue: [ self selected: self boidUnderCursor ].!
 
doubleClicked
	" Private - The left mouse button has been doubleClicked. "

	super doubleClicked.
	self detectSelected.!

followMouse
	" Private - Follow the mouse with the camera. "

	self isValid ifFalse: [ ^self ].
	self
		followMouseX;
		followMouseY;
		yourself.!
   
followMouseX
	" Private - Follow the mouse X coordinate with the camera. "

	| xForm delta speed |
	self isValid ifFalse: [ ^self ].
	speed := 50.
	delta :=self pane extent // 2
		- self pane mouseLocation.
	delta := delta x > 0
		ifTrue: [ 1 ]
		ifFalse: [ -1 ].
	xForm := self navigator xForm.
	self navigator
		tryToMoveIn: self space
		to: (
		  xForm position
			add: xForm left
			scaledBy: delta * speed).!
  
followMouseY
	" Private - Follow the mouse Y coordinate with the camera. "

	| xForm delta speed |
	self isValid ifFalse: [ ^self ].
	speed := 50.
	delta :=self pane extent // 2
		- self pane mouseLocation.
	delta := delta y > 0
		ifTrue: [ 1 ]
		ifFalse: [ -1 ].
	xForm := self navigator xForm.
	self navigator
		tryToMoveIn: self space
		to: (
		  xForm position
			add: xForm in
			scaledBy: delta * speed).!

followSelected
	" Private - Follow the selected object. "

	| point xForm distance |
	self selected isNil ifTrue: [ ^self ].
	distance := self scale / 5 * self selected body boundingBox diagonal length negated.
	xForm := self selected body xForm.
	point := xForm position
		add: xForm in
		scaledBy: distance.
	point y: 107 * self scale // 5 + point y. "overhead offset"

	self navigator xForm:
		(point xFormPointingTo: xForm position)!
  
followSelector
	"Returns the instance var of the receiver
	 for external manipulation"

	followSelector isNil ifTrue: [ self initializeFollowSelector ].
	^followSelector!
 
followSelector: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	followSelector := anObject!

followSelectorMenu
	" Private - Returns the follow selector menu. "

	| menu |
	menu := Menu new
		owner: self;
		title: '&Mode';
		appendItem: '&clear' selector: #unselect;
		appendSeparator;
		appendItem: '&follow' selector: #setToFollowSelected;
		appendItem: '&look' selector: #setToLookSelected;
		yourself.
	^menu!

highlightSelection
	" Private - Hightlight the current selection. "

	self selected notNil ifTrue: [ self selected highlight ].!
 
incrementScale
	" Private - Increment the scale factor. "

	self scale: self scale + 0.5!

initializeFollowSelector
	" Private - Initializes the receiver's followSelector"

	followSelector := #lookSelected.!
 
initializePrototypicalBoids
	" Private - Initialize the prototypical Boid specimens. "

	CursorManager execute changeFor: [
		prototypicalBoids := GenesisBoid prototypesFor: self space.
	].!
 
initializeScale
	" Private - Initializes the receiver's scale"

	scale := 5. "The scale is used for various effects."!
   
initializeSpaceManager
	" Private - Initializes the receiver's spaceManager"

	super initializeSpaceManager.
	self view
		when: #aboutToRender:
		send: #stepBoids:
		to: self.!
 
initializeTracking
	" Private - Initialize tracking actions. "

	super initializeTracking.
	self space notNil ifTrue: [ self startTracking ].!
  
inspectBoids
	" Private - Inspect the boids. "

	self boids inspect.!

inspectIt
	" Private - Inspect the object under cursor. "

	| object |
	object := self boidUnderCursor.
	object notNil ifTrue: [ object inspect ].!

inspectSelected
	" Private - Inspect the selected boid. "

	self selected notNil ifTrue: [
		self selected inspect
	].!

killAll
	" Private - Remove all the objects. "

	self selected: nil.
	self boids copy do: [:each| self killBoid: each ].!
   
killBoid: aBoid
	" Private - Kill aBoid in the space. "

	self space removeBoid: aBoid.!
 
killIt
	" Private - Kill the object under cursor. "

	| object |
	object := self boidUnderCursor.
	object notNil ifTrue: [
		(self confirm: 'Are you sure to kill ', object printString,' ?')
		ifTrue: [ self killBoid: object ].
	].!
 
killSelected
	" Private - Remove the selected object. "

	| victim |
	victim := self selected.
	victim notNil ifTrue: [
		self selected: nil.
		self killBoid: victim.
	].!
 
loadBoidsSpace
	" Private - Load the Boids space. "

	| fileName space |
	fileName := self worldPathName.
	CursorManager execute changeFor: [
		space := self spaceManager loadSpace: fileName.
		space notNil ifTrue: [
			self engine hideFrameRateCount.
			self spaceManager currentSpace: space.
		].
	].!
  
lookSelected
	" Private - Look to the selected object. "

	self navigator xForm: (self navigator position
		xFormPointingTo: self selected body position)!
  
mainMenu
	" Private - Returns the main menu. "

	^self boidsMenu
		appendSeparator;
		appendSubMenu: super mainMenu;
		yourself
"
	^super mainMenu
		insertSubMenu: self boidsMenu after: 0;
		insertSeparatorAfter: 1;
		yourself
"!
   
numberOfBoidsToSpawn
	" Private - Returns the initial number of boids. "

	Notifier isShiftKeyDown ifTrue: [ ^1 ]. "*debug*"
	^(self space volume
		 / 1000000000
		* 3 "boids per 1000x1000x1000 pixels"
	) asInteger max: 3!
   
prototypicalBoids
	" Private - Returns the prototypical Boid specimens. "

	prototypicalBoids isNil ifTrue: [
		self initializePrototypicalBoids
	].
	^prototypicalBoids!
 
randomizeBoids
	" Private - Randomize the boids. "

	self boids do: [:each| each randomize ].!
   
randomizeSelected
	" Private - Ramdomize the selected object. "

	self selected notNil ifTrue: [ self selected randomize ].!
 
scale
	"Returns the instance var of the receiver
	 for external manipulation"

	scale isNil ifTrue: [ self initializeScale ].
	^scale!
 
scale: aNumber
	"Sets the instance var of the receiver."

	scale := (aNumber max: 1) min: 10.
		"scale must be in this interval"!
   
selected
	"Returns the instance var of the receiver
	 for external manipulation"
	^selected!
 
selected: aBoid
	"Sets the selected aBoid."

	selected notNil ifTrue: [ selected unselect ].
	selected := aBoid.
	selected notNil ifTrue: [ selected select ].!

selectedMenu
	" Private - Returns the selected menu. "

	| menu |
	menu := Menu new
		owner: self;
		title: '&Selection';
		appendSubMenu: self followSelectorMenu;
		appendSeparator;
		appendItem: '&detect' selector: #detectSelected;
		appendItem: '&clear' selector: #unselect;
		appendItem: 'randomi&ze' selector: #randomizeSelected;
		appendItem: '&inspect' selector: #inspectSelected;
		appendSeparator;
		appendItem: '&motion...' selector: #setSelectedMotion;
		yourself.
	^menu!
 
setSelectedMotion
	" Lets the user change the motion of the selected boid."

	| body motionName names |
	body := self selected isNil ifFalse: [ self selected body ].
	body isNil ifTrue: [ ^self ].

	body hasMotions ifFalse: [
		^self message: 'The actor has no motions.'
	].
	names := body motionNames.
	motionName := (Menu
		labelArray: names
		lines: Array new
		selectors: names) popUp.
	motionName notNil ifTrue: [
		body motionName: motionName.
	].!
 
setToFollowSelected
	" Sets the receiver to followSelector mode."

	followSelector := #followSelected.!
  
setToLookSelected
	" Sets the receiver to lookSelected mode."

	followSelector := #lookSelected.
	self home.!
   
space
	" Private - Returns the receiver's space. "

	| space |
	space := super space.
	space isNil ifTrue: [ self loadBoidsSpace ].
	space := super space.
	space isNil ifTrue: [ ^self error: 'Space not found.' ].
	^space!
   
spaceManagerClass
	" Private - Must return the spaceManager support class."

   ^GenesisBoidsSpaceManager!
   
spawn: count cloneOf: aBoidPrototype
	" Private - Spawn aBoidPrototype in the space. "

	count timesRepeat: [ self spawnBoid: aBoidPrototype clone ].!
   
spawnAll
	" Private - Spawn the Boids in the space. "

	| prototypes |
	prototypes := ReadStream on: self prototypicalBoids.
	prototypes atEnd ifTrue: [
		^self error: 'Boids not found.'
	].
	(self numberOfBoidsToSpawn max: prototypes size)
	timesRepeat: [
		prototypes atEnd ifTrue: [ prototypes reset ].
		self spawn: 1 cloneOf: prototypes next.
	].!

spawnBoid: aBoid
	" Private - Spawn aBoid in the space. "

	self space addBoid: aBoid.!
  
spawnMany
	" Private - Spawn some boids selected by the user. "

	| count anAction |
	count := Prompter
		prompt: 'How many instances do you want to spawn ?'
		defaultExpression: 5 printString.
	count isNumber ifFalse: [ ^self ].

	anAction := (self spawnMenuFor: count of: self prototypicalBoids) popUp.
	anAction notNil ifTrue: [ anAction evaluate ].!
 
spawnMenu
	" Private - Returns the spawn menu. "

	| menu |
	menu := Menu new
		owner: self;
		title: 'Spa&wn';
		appendItem: '&all' selector: #spawnAll;
		appendSeparator;
		appendItem: '&one of...' selector: #spawnOne;
		appendItem: '&many of...' selector: #spawnMany;
		appendSeparator;
		appendItem: 'kill &selected' selector: #killSelected;
		appendItem: '&kill all' selector: #killAll;
		appendItem: 'kill &it' selector: #killIt;
		appendSeparator;
		appendItem: '&clear prototypes' selector: #clearPrototypes;
		yourself.
	^menu!
  
spawnMenuFor: count of: prototypes
	" Private - Returns the spawn menu. "

	| menu |
	menu := Menu new
		owner: self;
		title: '&Select a species to instantiate';
		yourself.
	self appendSpawn: count items: prototypes to: menu.
	self fullScreen ifTrue: [
		menu := self fullScreenMenuFrom: menu
	].
	^menu!
  
spawnOne
	" Private - Spawn a boid selected by the user. "

	| anAction |
	anAction := (self spawnMenuFor: 1 of: self prototypicalBoids) popUp.
	anAction notNil ifTrue: [ anAction evaluate ].!
   
stepBoids: seconds
	" Private - The renderer will render a frame. "

	self space stepBoids: seconds.

	self selected notNil ifTrue: [
		self perform: self followSelector.
		self highlightSelection.
	].!
  
unselect
	"Clear selected object."

	self selected: nil.!

worldPathName
	" Private - Returns the receiver's world path name."

	^'levels\Boids.bsp'! !
